/*
 *  Ces fonctions permettent de simuler la fonction getch()
 *  de conio.h (indisponnible sous Unix / Linux) via getchar()
 *  en modifiant les options du terminal.
 *
 *  Astuce trouve sur http://www.developpez.net/forums/viewtopic.php?t=42771
 *  et approfondie sur http://www.developpez.net/forums/viewtopic.php?t=69142
 */

#include <termios.h>				/* Modifier le comportement du terminal */
#include <string.h> 				/* memcpy() */

struct termios term, back;

// FIXME: Commentaires de description dans le fichier .h au lieu d'ici ?
//  Ou dans les deux fichiers .cpp et .h ?

/*
 *  Paramtrer le terminal pour que les prochains appels de getch()
 *  renvoient le caractre tapp sans attendre (renvoi -1 si aucune touche tappe).
 */
void init_getch()
{
	tcgetattr(0, &term);			/* Rcuprer les informations du terminal */
	memcpy(&back, &term, sizeof(term));	/* Les sauvegarder */

	term.c_lflag &= ~ (ICANON | ECHO);	/* Modifier les options du terminal */
	term.c_cc[VTIME] = 0;			/* Temps d'attente infini */
	term.c_cc[VMIN] = 0;			/* Nombre minimun de caractres */
	tcsetattr(0, TCSANOW, &term);		/* Modification des attribut de stdin */
}

/*
 *  Restaurer les attributs originaux afin d'obtenir un comportement normal des
 *  fonctions d'entres telles que getchar().
 */
void end_getch()
{
	tcsetattr(0, TCSANOW, &back);
}
